'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */


var _awsSdk = require('aws-sdk');

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_awsSdk.config.setPromisesDependency(_bluebird2.default);

class Connector {
  constructor({
    debug,
    tableName,
    timeout = process.env.DYNAMODB_TIMEOUT || process.env.TIMEOUT || 1000
  }) {
    this.debug = debug;
    this.tableName = tableName || /* istanbul ignore next */'undefined';
    this.db = new _awsSdk.DynamoDB.DocumentClient({
      httpOptions: {
        timeout
        // agent: sslAgent,
      },
      logger: { log: /* istanbul ignore next */msg => this.debug(msg) },
      convertEmptyValues: true
    });
  }

  update(inputParams) {
    const params = _extends({
      TableName: this.tableName
    }, inputParams);

    return this.db.update(params).promise().tap(this.debug).tapCatch(this.debug).catch( /* istanbul ignore next */err => {
      if (err.code === 'ConditionalCheckFailedException') {
        return {};
      }
      return _bluebird2.default.reject(err);
    });
  }
}

exports.default = Connector;