'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _awsSdk = require('aws-sdk');

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */
_awsSdk.config.setPromisesDependency(_bluebird2.default);

class Connector {
  constructor({
    debug,
    timeout = process.env.BUS_TIMEOUT || process.env.TIMEOUT || 1000
  }) {
    this.debug = debug;
    this.bus = new _awsSdk.EventBridge({
      httpOptions: {
        timeout
        // agent: sslAgent,
      },
      logger: { log: /* istanbul ignore next */msg => this.debug(msg) }
    });
  }

  putEvents(params) {
    return this.bus.putEvents(params).promise().tap(this.debug).tapCatch(this.debug);
  }
}

exports.default = Connector;