'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* eslint import/no-extraneous-dependencies: ["error", {"devDependencies": true}] */


var _awsSdk = require('aws-sdk');

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

_awsSdk.config.setPromisesDependency(_bluebird2.default);

class Connector {
  constructor({
    debug,
    streamName = process.env.STREAM_NAME,
    timeout = process.env.KINESIS_TIMEOUT || process.env.TIMEOUT || 1000
  }) {
    this.debug = debug;
    this.streamName = streamName || 'undefined';
    this.stream = new _awsSdk.Kinesis({
      httpOptions: {
        timeout
        // agent: sslAgent,
      },
      logger: { log: /* istanbul ignore next */msg => this.debug(msg) }
    });
  }

  putRecords(inputParams) {
    const params = _extends({
      StreamName: this.streamName
    }, inputParams);

    return this.stream.putRecords(params).promise().tap(this.debug).tapCatch(this.debug);
  }
}

exports.default = Connector;