'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.filterOnContent = exports.filterOnEventType = undefined;

var _latch = require('./latch');

Object.keys(_latch).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _latch[key];
    }
  });
});

var _skip = require('./skip');

Object.keys(_skip).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function () {
      return _skip[key];
    }
  });
});

var _isArray = require('lodash/isArray');

var _isArray2 = _interopRequireDefault(_isArray);

var _isFunction = require('lodash/isFunction');

var _isFunction2 = _interopRequireDefault(_isFunction);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const filterOnEventType = exports.filterOnEventType = (rule, uow) => {
  if (typeof rule.eventType === 'string') {
    return uow.event.type === rule.eventType;
  } else if (rule.eventType instanceof RegExp) {
    return rule.eventType.test(uow.event.type);
  } else if ((0, _isArray2.default)(rule.eventType)) {
    return rule.eventType.join().indexOf(uow.event.type) > -1;
  } else if ((0, _isFunction2.default)(rule.eventType)) {
    return rule.eventType(uow.event.type, rule);
  } else {
    throw new Error(`Rule: ${rule.id}, has improperly configured eventType filter. Must be a string, array of string, regex or function.`);
  }
};

const filterOnContent = exports.filterOnContent = (rule, uow) => {
  /* istanbul ignore else */
  if (rule.filters) {
    return rule.filters.reduce((a, c) => a && c(uow, rule), true);
  } else {
    return true;
  }
};