'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _utils = require('../utils');

var _filters = require('../filters');

const crud = rule => s => s.filter(_filters.outLatched).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toEvent(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through(rule.publish(rule)).tap(_utils.printEndPipeline);

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));
const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toEvent = rule => (0, _utils.faultyAsync)(uow => !rule.toEvent ? Promise.resolve(uow) : Promise.resolve(rule.toEvent(uow, rule)).then(event => _extends({}, uow, {
  event: _extends({}, uow.event, event)
})));

exports.default = crud;