'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _utils = require('../utils');

var _filters = require('../filters');

var _dynamodb = require('../utils/dynamodb');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const materialize = rule => s => s.filter(_filters.outSkip).filter(_filters.outSourceIsSelf).filter(onEventType(rule)).tap(_utils.printStartPipeline).filter(onContent(rule)).map(toUpdateRequest(rule)).parallel(rule.parallel || Number(process.env.PARALLEL) || 4).through((0, _dynamodb.update)(rule)).tap(_utils.printEndPipeline);

const onEventType = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnEventType)(rule, uow));
const onContent = rule => (0, _utils.faulty)(uow => (0, _filters.filterOnContent)(rule, uow));

const toUpdateRequest = rule => (0, _utils.faultyAsync)(uow => _bluebird2.default.resolve(rule.toUpdateRequest(uow, rule)).then(updateRequest => _extends({}, uow, {
  updateRequest
})));

exports.default = materialize;