'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toKinesisRecords = exports.fromKinesis = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const fromKinesis = exports.fromKinesis = event => (0, _highland2.default)(event.Records).map(record => (
// create a unit-of-work for each event
// so we can correlate related work for error handling
{
  record,
  event: Buffer.from(record.kinesis.data, 'base64').toString('utf8')
})).map((0, _utils.faulty)(uow => _extends({}, uow, {
  event: _extends({
    id: uow.record.eventID
  }, JSON.parse(uow.event))
})));

// test helper
const toKinesisRecords = exports.toKinesisRecords = events => ({
  Records: events.map((e, i) => ({
    eventSource: 'aws:kinesis',
    // eventVersion: '1.0',
    eventID: `shardId-000000000000:${i}`,
    // eventName: 'aws:kinesis:record',
    // invokeIdentityArn: 'arn:aws:iam::123456789012:role/lambda-role',
    awsRegion: 'us-west-2',
    // eventSourceARN: 'arn:aws:kinesis:us-west-2:123456789012:stream/lambda-stream',
    kinesis: {
      // kinesisSchemaVersion: '1.0',
      // partitionKey: e.partitionKey,
      sequenceNumber: `${i}`,
      data: Buffer.from(JSON.stringify(e)).toString('base64')
      // approximateArrivalTimestamp: 1545084650.987,
    }
  }))
});