'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.update = exports.timestampCondition = exports.updateExpression = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

var _merge = require('lodash/merge');

var _merge2 = _interopRequireDefault(_merge);

var _dynamodb = require('../connectors/dynamodb');

var _dynamodb2 = _interopRequireDefault(_dynamodb);

var _faults = require('./faults');

var _print = require('./print');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const updateExpression = exports.updateExpression = Item => ({
  ExpressionAttributeNames: Object.keys(Item).map(attrName => ({ [`#${attrName}`]: attrName })).reduce(_merge2.default, {}),
  ExpressionAttributeValues: Object.keys(Item).map(attrName => ({ [`:${attrName}`]: Item[attrName] })).reduce(_merge2.default, {}),
  UpdateExpression: `SET ${Object.keys(Item).map(attrName => `#${attrName} = :${attrName}`).join(', ')}`,
  ReturnValues: 'ALL_NEW'
});

const timestampCondition = exports.timestampCondition = (fieldName = 'timestamp') => ({
  ConditionExpression: `attribute_not_exists(#${fieldName}) OR #${fieldName} < :${fieldName}`
});

const update = exports.update = ({
  debug = (0, _print.debug)('dynamodb'),
  tableName = process.env.ENTITY_TABLE_NAME,
  updateRequestField = 'updateRequest',
  parallel = Number(process.env.UPDATE_PARALLEL) || Number(process.env.PARALLEL) || 4
} = {}) => {
  const connector = new _dynamodb2.default({ debug, tableName });

  const invoke = uow => {
    const p = connector.update(uow[updateRequestField]).then(updateResponse => _extends({}, uow, { updateResponse })).catch((0, _faults.rejectWithFault)(uow));

    return (0, _highland2.default)(p); // wrap promise in a stream
  };

  return s => s.map(invoke).parallel(parallel);
};