'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.faultyAsync = exports.faulty = exports.rejectWithFault = exports.throwFault = undefined;

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const throwFault = exports.throwFault = (uow, ignore = false) => err => {
  /* istanbul ignore else */
  if (!ignore) {
    // adorn the troubled uow
    // for processing in the errors handler
    err.uow = uow;
  }
  throw err;
};

const rejectWithFault = exports.rejectWithFault = (uow, ignore = false) => err => {
  /* istanbul ignore else */
  if (!ignore) {
    // adorn the troubled uow
    // for processing in the errors handler
    err.uow = uow;
  }
  return _bluebird2.default.reject(err);
};

const faulty = exports.faulty = funct => uow => {
  // eslint-disable-line consistent-return
  try {
    return funct(uow);
  } catch (e) {
    throwFault(uow)(e);
  }
};

const faultyAsync = exports.faultyAsync = funct => uow => (0, _highland2.default)(funct(uow).catch(rejectWithFault));