'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.toPromise = exports.toCallback = undefined;

var _highland = require('highland');

var _highland2 = _interopRequireDefault(_highland);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

const toCallback = exports.toCallback = cb => s => s.consume((err, x, push, next) => {
  if (err) {
    cb(err);
  } else if (x === _highland2.default.nil) {
    cb(null, 'Success');
  } else {
    next();
  }
}).resume();

const toPromise = exports.toPromise = s => new Promise((resolve, reject) => {
  s.consume((err, x, push, next) => {
    if (err) {
      reject(err);
    } else if (x === _highland2.default.nil) {
      resolve('Success');
    } else {
      next();
    }
  }).resume();
});